<?

/* Copyright (C) 2002 Mandrakesoft					*/
/* Authors :								*/
/* Enzo Maggi								*/
/* Renaud Chaillat							*/
/* Amaury Amblard-Ladurantie <amaury@mandrakesoft.com>			*/
/*									*/

/*
 Copyright (C) 2002 MandrakeSoft SA
 
 This program may be distributed and/or
 modified under the terms of the GNU General Public
 License version 2 as published by the Free Software Foundation
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 General Public License for more details.
 
 Licensees holding valid MandrakeSecurity MNF Commercial License may use this
 file in  accordance with the MandrakeSecurity MNF Commercial License Agreement
 provided with the Software.
 
 See http://www.mandrakesoft.com/mnf/license for information about MandrakeSecurity MNF Commercial License Agrrement.
*/ 

/**
 * This file provides most classes used by the frontend :
 	- navbar : generates the navbar
	- session : manages all session related stuff (login, pw, timeout and so on)
	- table : used to display content in tables (unused)
	- Lang_chooser : manages all i18n stuffs (multiple login frontends, which langs are installed...
	- trialversion : all trial version checks (version expired and so on...)
 */

class navbar {
  var $navdir;

  function navbar() {
    $this->navdir = "navbar";
  }	
  
  function getraw() {
    
    $this->dh =  dir($this->navdir);	// gets a directory handler
    
    if (!$this->dh) {
      return false;	// No directory handler
    } else {
      while (	$data = $this->dh->read()) {
	// TODO : check nabvar format
	
	if (ereg('^navbar',$data)) {
	  $this->dump[] = file($this->navdir.'/'.$data);
	}
      }
    }
    
    $this->dh->close();
		
    foreach ($this->dump as $filecontent) {
      foreach ($filecontent as $t) {
	$this->rawnav[] = $t;
      }
    }
		
    return true;
  }

  function make($where) {

    if (!$this->rawnav) {
      $this->getraw();
    }


    //if (!file_exists($this->navfile)) return false;
		
    //$rawnav = file($this->navfile);
    sort ($this->rawnav);
		
    $maintopic = $where - ($where % 100);
    $intertopic = $where - ($where % 10);
    $subtopic = $where;
		
    $subtopic_displayed = ""; 	// useful to check if a subtopic has already been displayed (to display the "|")
		
		
    $h = array();
    $v[] = '<table border="0" width="163" cellpadding="0" cellspacing="0">';
		
    foreach($this->rawnav as $line) {

      $rand = mt_rand(0,9999999);	// random string to change each URL -> no cache

      $data = explode("|",trim(chop($line)));
			
      $localmt = $data[0] - ($data[0] % 100);
      $localit = $data[0] - ($data[0] % 10);
      $localst = $data[0];
			
      $data[3] = rtrim($data[3]);
		
      if ($where == $data[0]) $t = $data[2]; 	// Get full title of current topic
			
      if (($data[0] % 100) == 0) {		// Main topic
	if ($maintopic == $localmt) {	// Current topic
	  $v[] = '<tr><td><img src="images/boob-on.png" alt="[-]"></td><td><a href="'.$data[3].'&r='.$rand.'" class="vnavbartitle-on">'.$data[1].'</a></td></tr>'."\n";
	} else {
	  $v[] = '<tr><td><img src="images/boob-off.png" alt="-" name="img-'.$data[0].'"></td><td><a href="'.$data[3].'&r='.$rand.'" class="vnavbartitle-off" onMouseOut="restore()" onMouseOver="swap(\'img-'.$data[0].'\',\'\',\'images/boob-mouse.png\',1)">'.$data[1].'</a></td></tr>'."\n";
	}
      } else if ((($data[0] % 10) == 0) && ($maintopic == $localmt)) {	// Medium Topic
	if ($intertopic == $localit) {
	  $v[] = '<tr><td>&nbsp;</td><td><img src="images/dot-green.png"  alt="	[-]"> <a href="'.$data[3].'&r='.$rand.'" class="vnavbarsub-on">'.$data[1].'</a></td></tr>'."\n";
	  $this->navtitle = $data[1];			// Needed for small topics hnav
	} else {
	  $v[] = '<tr><td>&nbsp;</td><td><img src="images/dot-white.png"  alt="	-" name="img-'.$data[0].'"> <a href="'.$data[3].'&r='.$rand.'" class="vnavbarsub-off" onMouseOut="restore()" onMouseOver="swap(\'img-'.$data[0].'\',\'\',\'images/dot-green.png\',1)">'.$data[1].'</a></td></tr>'."\n";
	}
      } else {				// Small Topic
	if ($intertopic == $localit) {
	  if($subtopic_displayed) {
	    $sep = ' | ';
	  } else {
	    $sep = '';
	  }
					
	  if ($subtopic == $localst) {	
	    $h[] = $sep.'<span class="hnavbarsub-on">'.$data[1].'</span>'."\n";
	  } else {
	    $h[] = $sep.'<a href="'.$data[3].'&r='.$rand.'" class="hnavbarsub-off">'.$data[1].'</a>'."\n";
	  }
					
	  $subtopic_displayed = "1";
	}			
      }
    }
    $v[] = '<tr><td><p><img src="images/blue-bg.png" width="21" height="85" >&nbsp;</p></td><td><p>&nbsp;</p></td></tr>'."\n";
    $v[] = '<tr><td><img src="images/logout2.png" width="16" height="16" border="0" alt="logout" title="logout"></td>'."\n";
    $v[] = '<td width="*"><a href="../logout.php" class="vnavbartitle-off">Logout</a></td></tr>'."\n";
    $v[] = '</table>';
		
    if ($this->navtitle) {
      $hpre = '<span class="hnavbartitle">'.$this->navtitle.' &gt;</span> '."\n";
      array_unshift($h, $hpre);
    }
		
    $this->title = $t;
    $this->vnav = $v;
    $this->hnav = $h;
  }
}


class session {

  function session() {
    $this->cdate = date("Y-m-d H:i:s");
    $this->fingerprint();
  }

  function error($msg) {
    header("Location: ".LOGINURL.'?msg='.rawurlencode($msg));
    exit;
  }

  // Print the login form
  function print_error($msg="login")
    {
      $encodedmsg = rawurlencode($msg);
      header("Location:index.php?msg=".$encodedmsg);
      exit;
    }

  function get_vars($v) {		// return an array of variables from the frontend or the backend
	
    // first loop : we only collect data to create the backend request string
    foreach ($v as $l) {
      if (eregi("^frontend_param(.+)",$l,$r)) {	// frontend value
	continue;
      } else {					// backend value
	$str .= ' --get '.$l." ";		// creates the string to give to the backend
      }
    }
		
    $str = trim(chop(strip_tags(ereg_replace("[`;]","",$str))));
		
		
    $progstr = 'config-wrapper.pl '.$this->id.'  '.$str.' ';	// asks the data to the backend
    exec ($progstr,$ret);

    // second loop : we globalize needed frontend value or collect the values returned by the backend
    foreach ($v as $l) {
      if (eregi("^frontend_param(.+)",$l,$r)) {	// frontend value -> nothing needed
	global ${$l};
	$res[] = ${$l};
      } else {					// backend value
	list ($key, $val) = each($ret);					
	$res[] = $val;
      }
    }
		
    return $res;
  }


  function init_vars() {
	
    global $mdk_sessid;

    // First loop : Get the Variable part of the multipart values
    foreach ($this->var as $l) {
      if (eregi('^\$\{(.+)\}(.+)',$l,$r)) {	// multipart var
	// Found a multipart var -> we have to get the full variable name
	$v[] = $r[1];
      }
    }
    $c = $this->get_vars($v);		// get pieces of variable names from the backend or the frontend;
    // Second loop : Get the whole value
    foreach ($this->var as $l) {
      if (eregi('^\$\{(.+)\}(.+)',$l,$r)) {	// multipart var
	list ($key, $val) = each($c);
	${$r[1]} = $val;
				
	$g[] = ${$r[1]}.$r[2];		// a backend value
				
      } else {
	$g[] = $l;			// maybe a backend, or a frontend
      }
    }
		
    $c = $this->get_vars($g);		// get the values names from the backend or the frontend;	
		
    // third loop : let's globalize the variables
    foreach ($g as $v) {
      list ($key, $val) = each($c);
      $this->vars[$v] = $val;
    }
  }

  function fingerprint() {				// Calculates the fingerprint for the system...
    global $HTTP_USER_AGENT, $REMOTE_ADDR,$HTTP_X_FORWARDED_FOR;
    $this->fp = md5($HTTP_X_FORWARDED_FOR.$HTTP_USER_AGENT.$REMOTE_ADDR);
  }

  function get_file($id="") {				// return the name of the session file
    global $mdk_sessid;
		
    if ((!$mdk_sessid) && (!$id)) return false;
		
    if ($id) {
      $mdk_sessid = $id;
    }
		
    $mdk_sessid = ereg_replace('[^a-zA-Z0-9]', "", $mdk_sessid);		// remove nasty chars
    $this->id = $mdk_sessid;
    if(strlen($this->id) != 32) return false;
		
    $this->file = VARDIR.$this->id.".session.php";
		
    return true;
  }
		
  function rm_cookies() {
    setcookie ("mdk_userid",'', time() - 36000);	// erase cookies
    setcookie ("mdk_sessid",'', time() - 36000);
  }
	
  function rm_sessionfile() {
    if ($this->get_file()) {				// remove old session file	
      if(file_exists($this->file)) unlink($this->file);
    }
		
    $statusfile = VARDIR.$this->id.'.status';
    $histfile = VARDIR.$this->id.'.history';
		
    if(file_exists($statusfile)) unlink($statusfile);
    if(file_exists($histfile)) unlink($histfile);
  }
	
  function check_lp() {
    global $login, $password;

    $login = escapeshellcmd($login);
    $password = escapeshellcmd($password);
	
    // $login = trim(chop(strip_tags(ereg_replace("[`;]","",$login))));
    // $password = trim(chop(strip_tags(ereg_replace("[`;]","",$password))));
		
    if(!$login) return false;

    if($login != ADMINLOGIN) return false;
		
    $this->login = $login;
    $this->password = $password;
		
    // return true;
    return !$this->trypass();
  }

  // Try Authentication against pam modules
  // TODO: define group access
  function trypass() {
    unset($ret);
    unset($pwauth_path);
		if(file_exists("/usr/lib/apache2-extramodules/pwauth")) {
			$pwauth_path= "/usr/lib/apache2-extramodules/pwauth";
    } else {
			if(file_exists("/usr/lib/apache/pwauth")) {
				$pwauth_path= "/usr/lib/apache/pwauth";
      }
    }
    system("/bin/echo -e \"".$this->login."\n".$this->password."\n\" |".$pwauth_path,$ret);
    return $ret;
  }


  function change_mtime() {
    if (!$this->get_file($this->id)) return ("Could not get session filename");	// get session filename
    if(!touch($this->file, time()))	return ("Could not update session mtime");	// update session mtime 
    return true;
  }

  function timein() {
		
    if (!$this->get_file($mdk_sessid)) return ("Could not get session filename");	// get session filename

    if(!file_exists($this->file)) {
      return ("Session file not found");
    } 	

    //		if (!$this->flastload) return false;
    //		if ( (time() - $this->flastload) > TIMEOUT) {

    if ( (time() - filemtime($this->file)) > TIMEOUT) {
      return false;
    } else {
      return true;
    }
  }

  function check_session() {		// check if a session is OK
	
    global $mdk_userid, $mdk_sessid;
    if ((!$mdk_userid) || (!$mdk_sessid)) {
      return ("Cookies not found");
    }
		
    if (!$this->get_file($mdk_sessid)) return ("Could not get session filename");	// get session filename
		
    if(!file_exists($this->file)) {
      return ("Session file not found");
    } else include($this->file);				// FIXME : ***CHECK SECURITY HOLES HERE ******
		
    if($this->fuserid != $this->fp) return ("***WARNING*** IDENTIFIERS DON'T MATCH  (Security flaw ?)");
		
    return true;
  }

  function back_pressed() {		// check if the back button is pressed
	
    global $mdk_sessid, $where, $loadfile, $asked_page_dir, $tag;
    /*
     * Handle the browser 'back' button
     * First check that the scenario loaded is the current one (i.e. 'loadfile' value matches the <current>.wvm directory)
     * If not, tell the engine to restart the 'loadfile' scenario
     *
     * Then check if tag matches CT
     * If not, display a warning message to tell users to use the navbar and redisplay the current page.
     *
     */
	 
    $history_filename = VARDIR.$this->id.'.history';
		
    if (! file_exists($history_filename)) {
      // file does not exists -> should be step 1 
      // print "does not exist";
      return true;
    } else {
      $fp = fopen ($history_filename,"r");
      if ( $fp ) {
	// analyze 'loadfile' url parameter
	$asked_page_dir = dirname ($loadfile);
				
	// context ('where') as written in the history
	$where_read = fgets ($fp, 4096);

	// Get needed info in history file
	$wvm_dir = fgets ($fp, 4096);
	$wvm_filename = basename ($wvm_dir);
	$wvm_dir = dirname ($wvm_dir);
	$last_page_file = fgets ($fp, 4096);
	$last_page_file = chop ($last_page_file);
	$CT = fgets ($fp, 128);
	$CT = trim(chop($CT));
	fclose ($fp);
				
	//print '$CT = '.$CT.'<br>';
	//print '$wvm_dir = '.$wvm_dir.'<br>';
	//print '$asked_page_dir = '.$asked_page_dir.'<br>';
	//print '$tag = '.$tag.'<br>';
				
	if ( $where ) $where_str = 'where='.$where.'&';
				
	// Does the asked url matches the current scenario ?
	if ( $asked_page_dir && $wvm_dir && ($asked_page_dir != $wvm_dir) ) {
	  // print "This directory $asked_page_dir is not the current directory $wvm_dir\n";
	  // print "Url to set: engine.php?".$where_str."file=".$asked_page_dir."/".$asked_page_dir.".wvm&cmd=start<br>";

	  // Reset the wvm corresponding to the directory asked
	  header("Location: engine.php?".$where_str."file=".$asked_page_dir."/".$asked_page_dir.".wvm&cmd=start");
	  exit;
	}
				
	if ( $tag && ($tag != $CT)) {
	  // print "Tag and CT don t match !<br>";
	  // print "Tag is **".$tag."** and CT is **".$CT."** !<br>";
	  // print "Url to set: index.php?".$where_str."tag=".$CT."&loadfile=".$last_page_file."\n";

	  // Redisplay the same page without bothering the engine
	  // TODO: insert an information message in the page
	  // We may try to see if previous/forward was allowed in the 
	  // previous page (this requires to know and store that info) 
	  // and call the engine...
	  header ("Location: index.php?".$where_str."tag=".$CT."&loadfile=".$last_page_file."&warning=1");
	  exit;
	}
      }
    }
    return true;
  }

  function login() {
	
    if (!$this->fp) $this->fingerprint();		// Calculate system identifier
	
    if (!$this->check_lp()) return ("Wrong Login/Password");		// Check Login and Password

    $this->rm_sessionfile();				// Close old session file (if any)
    $this->rm_cookies();

    $this->id = md5(uniqid(mt_rand(),1));		// Calculates session ID
		
    $this->maxtime = time() + TIMEOUT;
		
    setcookie ("mdk_userid", $this->fp ,$this->maxtime);	// creates cookies (time to live :  hours)
    setcookie ("mdk_sessid", $this->id ,$this->maxtime);
		
    if (!$this->get_file($this->id)) return ("Could not get session filename");	// get session filename

    if(!touch($this->file, time()))	return ("Could not create session file");	// create session (time() is here to fix a PHP bug : must be specified)

    chmod($this->file, 0600);
		
    if (($f=fopen($this->file,"w")))			// Put data in the session file
      {
	$string = '<?php'."\n\n";				// as we are smart -> PHP
	$string .= "// This is a generated file - please do not edit...\n\n";
	$string .= "\$this->flastload = \"".time()."\";\n";
	$string .= "\$this->flogin = \"".$this->login."\";\n";
	$string .= "\$this->fuserid = \"".$this->fp."\";\n";
	$string .= "\$this->fsessid = \"".$this->id."\";\n";
	$string .= "\n".'?>'."\n";	
                
	flock($f, "2");
	fputs($f,$string);
	flock($f, "3");
	fclose($f);
      } else return ("Could not fill session file");
		
    return true;
  }

  function surf() {
    if (!$this->fp) $this->fingerprint();		// Calculate system identifier

    $session_state = $this->check_session();		// Check if there is a valid session	
    if($session_state != "true") return ("No session found : <i>".$session_state."</i>\n");

    if (!$this->timein()) {			// Check timeout
      header('Location: '.STARTURL.'?msg='.urlencode("Session time out. Please login"));
      //return ("Session timeout\n");
    }
		
    if(!$this->back_pressed()) return ("Could not validate navigation way\n");
		
    // Update lastload time
    if (!$this->change_mtime()) return ("Could not update mtime\n");
		
    return true;
  }

  function logout() {
    if (!$this->get_file()) return ("Could not get session filename");
    if(!$this->check_session()) return ("No session found");	// Check if there is a valid session	
    $this->rm_sessionfile();					// Close old session (if any)
    $this->rm_cookies();
  }
}


class table {
	
  function table() {
    return true;
  }
	
  function givemejunk() {		// produces random data to fill the table (DEBUG purpose)
		
    $this->cols = mt_rand(2,10);
    $this->rows = mt_rand(2,15);
		
    for ($i = 0; $i <$this->rows ; $i++) {
      for ($j = 0; $j <$this->cols ; $j++) {
	$sub = mt_rand(0,25);
	$txt = substr(md5(uniqid(mt_rand(),1)), 0, $sub);
	$junk[$i][$j] = $txt;
      }
    }
    return $junk;
  }

  function format_multiplelist() { // Format a list of stuff (eg : table of ethX settings)
	
    if (!$this->rdata) { // No data as input -> produces some random data
      $this->rdata = $this->givemejunk();
    }
	
    $first_row = true;	// is this the first row of the table ?
    $row_type = 1;		// is this a even or odd row ?
	
    foreach ($this->rdata as $row) {
      $out .='<tr>'."\n";
      foreach ($row as $cell) {
	// class selection
	if ($first_row) {	// is this the first row ?
	  $type = 'tabtitle';
	} else $type = 'tabcont'.$row_type;	// even or odd row ?
	if(!$cell) $cell = '-';
	$out .='<td class="'.$type.'">'.$cell.'</td>'."\n";		
      }
      $out .='</tr>'."\n";
      $first_row = false; // first row is passed
      $row_type = ($row_type + 1) %2;
    }
		
    $pre = '<table class="data">'."\n";
    $post = '</table>'."\n";
    $out = $pre.$out.$post;
		
    $this->rformated = $out;
		
    return true;
  }
	
  function format_singlelist() { // Format a container of stuff (eg : misc system information)

    if (!$this->cdata) { // No data as input -> produces some random data
      $this->cdata = $this->givemejunk();
    }
		
    $row_type = 0;	
		
    foreach ($this->cdata as $row) {
      $out .='<tr>'."\n";
      $first_col = true;	// first col ?
      foreach ($row as $cell) {
	if ($first_col) {	// is this the first column ?
	  $type = 'tabtitle';
	  $first_col = false;	//only 1 first col per row...
	} else $type = 'tabcont'.$row_type;	// even or odd row ?
	if(!$cell) $cell = '-';
	$out .='<td class="'.$type.'">'.$cell.'</td>'."\n";		
      }
      $out .='</tr>'."\n";
      $row_type = ($row_type + 1) %2;
    }
		
    $pre = '<table class="data">'."\n";
    $post = '</table>'."\n";
    $out = $pre.$out.$post;
		
    $this->cformated = $out;
    return true;
  }
	
  function format_singletitlelist() {

    if (!$this->cdata) { // No data as input -> produces some random data
      $this->cdata = $this->givemejunk();
    }

    $first_cell = true;
    $first_row = true;
    $rowspan = 'rowspan="'.sizeof ($this->cdata).'"';
    $row_type = 0;		
		
    foreach ($this->cdata as $row) {
      $out .='<tr>'."\n";
      foreach ($row as $cell) {

	if (($first_cell) && ($first_row)) {
	  $type = 'tabtitle';
	} else {
	  $type = 'tabcont'.$row_type;	// even or odd row ?
	}
				
	if (($first_cell) && (!$first_row)) {
	  $first_cell = false;
	  continue;
	}

	if(!$cell) $cell = '-';
	$out .='<td class="'.$type.'" '.$rowspan.'>'.$cell.'</td>'."\n";
	$first_cell = false;
	$rowspan = '';
      }
      $out .='</tr>'."\n";
      $row_type = ($row_type + 1) %2;
      $first_row = false;
      $first_cell = true;
    }
		
    $pre = '<table class="data">'."\n";
    $post = '</table>'."\n";
    $out = $pre.$out.$post;
		
    $this->csformated = $out;
    return true;
  }
}


class Lang_chooser {
	
  function get_available() {	// return available langages

    $this->dh =  dir(LANGDIR);	// gets a directory handler
		
    if (!$this->dh) {
      return false;	// No directory handler
    } else {
      while (	$data = $this->dh->read()) {
			
	if ($data != "." && $data != ".." && $data != "genfiles" && $data != "CVS" && $data != "secure" && $data != "css" && $data != "php" && $data != "images") {
	  if (is_dir($data)) $this->dirs[] = $data;
	}
      }
			
      $this->dh->close();		
    }
  }
	
  function set_chosen() {		// remember the chosen lang
    if(!$this->lang) $this->get_current();
    setcookie (LANGCOOKIE, $this->lang ,time() + 1000000, '/');
  }
	
  function get_current() {	// get the current lang
    global $HTTP_SERVER_VARS; 
    $this->lang = ereg_replace(LANGDIR,'',dirname($HTTP_SERVER_VARS['SCRIPT_FILENAME']));
  }
	
  function get_redirect() {
    global ${LANGCOOKIE};

    //global $mdk_lang;
		
    // print '${LANGCOOKIE} -> $'.LANGCOOKIE.' -> '.${LANGCOOKIE}."<br>\n";
		
    // tries to default the lang to english...
    $test = 'false';
    $l = 'en';
    foreach($this->dirs as $t) {
      if ($t == $l) $test = 'true';		// does the english exist ?
    }
    if ($test == 'true') {
      $this->url = $l;
    } else {
      $this->url = $this->dirs[0];		// if not, take the first lang of the array...
    }
		
    // gets the (optional) lang from a cookie and check if the lang is installed
    if (${LANGCOOKIE}) {
		
      $test = 'false';
      foreach($this->dirs as $t) {
	if (${LANGCOOKIE} == $t) $test = 'true';		// does the chosen lang exist ?
      }
			
      if ($test == 'true') $this->url = ${LANGCOOKIE};
    }		
  }
	
  function make_html() {		// formats the table containing the langs
    if (!$this->dirs) $this->get_available();
		
    $trans =  array (
		     'en' => 'English',
		     'fr' => 'Franais',
		     'es' => 'Espaol',
		     'it' => 'Italiano',
		     'de' => 'Deutsh',
		     'pt' => 'Portugs',
		     );
		
    foreach ($this->dirs as $t) {
      // translate en->ENglish and so on...
      if ($trans[$t]) {
	$a = $trans[$t];
      } else {
	$a = $t;
      }
			
      $this->html .= '<td><a href="../'.$t.'/"><img src="images/flag-'.$t.'.png" border="0" alt="'.$a.'" title="'.$a.'"> '.$a.'</a></td>'."\n";
    }
		
    $this->html = '<table width="100%" class="lang"><tr>'.$this->html;
    $this->html = $this->html.'</tr></table>';
  }
}



class trialversion {

  function trialversion() {				// constructor

    $this->file = TRIALDIR.TRIALFILE;

    if(TRIALACTIVE == 'false') {			// trial is active (demo version)
      return true;
    } else {

      // tests if the trial test file exists
      if(!file_exists($this->file)) {

	$this->filemtime = time();

	// if it does not exist, create it
	if(!touch($this->file, $this->filemtime)) return false;
	chmod($this->file, 0600);
	
	if (($f=fopen($this->file,"w"))) {
	  $rd = $this->mk_random_str();
	  
	  $this->make_secret($rd,$this->filemtime);

	  $string = $rd."\n";
	  $string.= $this->filemtime."\n";
	  $string.= $this->secret."\n";
	  flock($f, "2");
	  fputs($f,$string);
	  flock($f, "3");
	  fclose($f);
	  
	  if(!touch($this->file, $this->filemtime)) return false;	// reset last modification date
	}
      } else return true; // trial file exists
    }
    return true;
  }

  function make_secret($str1, $str2) {				// makes the pseudo secret hash (l33t c0d3 !!!)
    if(($str1 == '') ||($str2 == '')) return false;

    $this->secret = md5($str1.$str2."xx");

    return true;
  }
  
  function is_over() {					// check if trial period is over
    if(TRIALACTIVE == 'false') {			// trial is inactive (full version)
      return false;
    }

    if(!file_exists($this->file)) return true;

    $timeused = time() - filemtime($this->file);
    
    if($timeused < 0) return true;
    if($timeused > TRIALTIMEOUT) return true;
    
    $trdata = file($this->file);

    $trdata[0] = chop($trdata[0]);
    $trdata[1] = chop($trdata[1]);
    $trdata[2] = chop($trdata[2]);

    if(filemtime($this->file) != $trdata[1]) return true;

    $this->make_secret($trdata[0], $trdata[1]);
    if($this->secret != $trdata[2]) return true;

    return false;
  }

  function mk_random_str($len = '30') {			// make random string
    $str = array ('a', 'b', 'c', 'd', 'e' ,'f', 'g', 'h', 'i', 'j', 
		  'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 
		  'u', 'v', 'w', 'x', 'y', 'z', '0', '1', '2', '3', 
		  '4', '5', '6', '7', '8', '9', '-', '_'); 
    $max = sizeof($str) -1;
    $rand = '';

    for ($i = 0; $i < $len; $i++) {
      $rand .= $str[mt_rand (0,$max)];
    }

    return $rand;
  }
}

			
?>
